/* utils.c generated by valac 0.56.17, the Vala compiler
 * generated from utils.vala, do not modify */

/*      utils.vala*/
/*      */
/*      Copyright 2011 Hong Jen Yee (PCMan) <pcman.tw@pcman.tw@gmail.com>*/
/*      */
/*      This program is free software; you can redistribute it and/or modify*/
/*      it under the terms of the GNU General Public License as published by*/
/*      the Free Software Foundation; either version 2 of the License, or*/
/*      (at your option) any later version.*/
/*      */
/*      This program is distributed in the hope that it will be useful,*/
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*      GNU General Public License for more details.*/
/*      */
/*      You should have received a copy of the GNU General Public License*/
/*      along with this program; if not, write to the Free Software*/
/*      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,*/
/*      MA 02110-1301, USA.*/
/*      */
/*      */

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include "fm-actions.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))

VALA_EXTERN gchar* utils_key_file_get_string (GKeyFile* kf,
                                  const gchar* group,
                                  const gchar* key,
                                  const gchar* def_val);
VALA_EXTERN gchar** utils_key_file_get_string_list (GKeyFile* kf,
                                        const gchar* group,
                                        const gchar* key,
                                        gchar** def_val,
                                        gint def_val_length1,
                                        gint* result_length1);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
VALA_EXTERN gchar* utils_key_file_get_locale_string (GKeyFile* kf,
                                         const gchar* group,
                                         const gchar* key,
                                         const gchar* def_val);
VALA_EXTERN gboolean utils_key_file_get_bool (GKeyFile* kf,
                                  const gchar* group,
                                  const gchar* key,
                                  gboolean def_val);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

gchar*
utils_key_file_get_string (GKeyFile* kf,
                           const gchar* group,
                           const gchar* key,
                           const gchar* def_val)
{
	gchar* val = NULL;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 24 "utils.vala"
	g_return_val_if_fail (kf != NULL, NULL);
#line 24 "utils.vala"
	g_return_val_if_fail (group != NULL, NULL);
#line 24 "utils.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 84 "utils.c"
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 27 "utils.vala"
		_tmp1_ = g_key_file_get_string (kf, group, key, &_inner_error0_);
#line 27 "utils.vala"
		_tmp0_ = _tmp1_;
#line 27 "utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27 "utils.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 97 "utils.c"
				goto __catch0_g_key_file_error;
			}
#line 27 "utils.vala"
			_g_free0 (val);
#line 27 "utils.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 27 "utils.vala"
			g_clear_error (&_inner_error0_);
#line 27 "utils.vala"
			return NULL;
#line 108 "utils.c"
		}
#line 27 "utils.vala"
		_tmp2_ = _tmp0_;
#line 27 "utils.vala"
		_tmp0_ = NULL;
#line 27 "utils.vala"
		_g_free0 (val);
#line 27 "utils.vala"
		val = _tmp2_;
#line 26 "utils.vala"
		_g_free0 (_tmp0_);
#line 120 "utils.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		gchar* _tmp3_;
#line 26 "utils.vala"
		g_clear_error (&_inner_error0_);
#line 30 "utils.vala"
		_tmp3_ = g_strdup (def_val);
#line 30 "utils.vala"
		_g_free0 (val);
#line 30 "utils.vala"
		val = _tmp3_;
#line 134 "utils.c"
	}
	__finally0:
#line 26 "utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26 "utils.vala"
		_g_free0 (val);
#line 26 "utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 26 "utils.vala"
		g_clear_error (&_inner_error0_);
#line 26 "utils.vala"
		return NULL;
#line 147 "utils.c"
	}
#line 32 "utils.vala"
	result = val;
#line 32 "utils.vala"
	return result;
#line 153 "utils.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 41 "utils.vala"
	if (length >= 0) {
#line 162 "utils.c"
		gchar** result;
		gssize i;
#line 41 "utils.vala"
		result = g_new0 (gchar*, length + 1);
#line 41 "utils.vala"
		for (i = 0; i < length; i++) {
#line 169 "utils.c"
			gchar* _tmp0_;
#line 41 "utils.vala"
			_tmp0_ = g_strdup (self[i]);
#line 41 "utils.vala"
			result[i] = _tmp0_;
#line 175 "utils.c"
		}
#line 41 "utils.vala"
		return result;
#line 179 "utils.c"
	}
#line 41 "utils.vala"
	return NULL;
#line 183 "utils.c"
}

gchar**
utils_key_file_get_string_list (GKeyFile* kf,
                                const gchar* group,
                                const gchar* key,
                                gchar** def_val,
                                gint def_val_length1,
                                gint* result_length1)
{
	gchar** val = NULL;
	gint val_length1 = 0;
	gint _val_size_ = 0;
	gchar** _tmp5_;
	gint _tmp5__length1;
	GError* _inner_error0_ = NULL;
	gchar** result;
#line 35 "utils.vala"
	g_return_val_if_fail (kf != NULL, NULL);
#line 35 "utils.vala"
	g_return_val_if_fail (group != NULL, NULL);
#line 35 "utils.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 207 "utils.c"
	{
		gchar** _tmp0_ = NULL;
		gsize _tmp1_ = 0;
		gchar** _tmp2_;
		gint _tmp0__length1;
		gint __tmp0__size_;
		gchar** _tmp3_;
		gint _tmp3__length1;
#line 38 "utils.vala"
		_tmp2_ = g_key_file_get_string_list (kf, group, key, &_tmp1_, &_inner_error0_);
#line 38 "utils.vala"
		_tmp0_ = _tmp2_;
#line 38 "utils.vala"
		_tmp0__length1 = _tmp1_;
#line 38 "utils.vala"
		__tmp0__size_ = _tmp0__length1;
#line 38 "utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 38 "utils.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 228 "utils.c"
				goto __catch0_g_key_file_error;
			}
#line 38 "utils.vala"
			val = (_vala_array_free (val, val_length1, (GDestroyNotify) g_free), NULL);
#line 38 "utils.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 38 "utils.vala"
			g_clear_error (&_inner_error0_);
#line 38 "utils.vala"
			return NULL;
#line 239 "utils.c"
		}
#line 38 "utils.vala"
		_tmp3_ = _tmp0_;
#line 38 "utils.vala"
		_tmp3__length1 = _tmp0__length1;
#line 38 "utils.vala"
		_tmp0_ = NULL;
#line 38 "utils.vala"
		_tmp0__length1 = 0;
#line 38 "utils.vala"
		val = (_vala_array_free (val, val_length1, (GDestroyNotify) g_free), NULL);
#line 38 "utils.vala"
		val = _tmp3_;
#line 38 "utils.vala"
		val_length1 = _tmp3__length1;
#line 38 "utils.vala"
		_val_size_ = val_length1;
#line 37 "utils.vala"
		_tmp0_ = (_vala_array_free (_tmp0_, _tmp0__length1, (GDestroyNotify) g_free), NULL);
#line 259 "utils.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		gchar** _tmp4_;
		gint _tmp4__length1;
#line 37 "utils.vala"
		g_clear_error (&_inner_error0_);
#line 41 "utils.vala"
		_tmp4_ = (def_val != NULL) ? _vala_array_dup1 (def_val, def_val_length1) : def_val;
#line 41 "utils.vala"
		_tmp4__length1 = def_val_length1;
#line 41 "utils.vala"
		val = (_vala_array_free (val, val_length1, (GDestroyNotify) g_free), NULL);
#line 41 "utils.vala"
		val = _tmp4_;
#line 41 "utils.vala"
		val_length1 = _tmp4__length1;
#line 41 "utils.vala"
		_val_size_ = val_length1;
#line 280 "utils.c"
	}
	__finally0:
#line 37 "utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 37 "utils.vala"
		val = (_vala_array_free (val, val_length1, (GDestroyNotify) g_free), NULL);
#line 37 "utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 37 "utils.vala"
		g_clear_error (&_inner_error0_);
#line 37 "utils.vala"
		return NULL;
#line 293 "utils.c"
	}
#line 43 "utils.vala"
	_tmp5_ = val;
#line 43 "utils.vala"
	_tmp5__length1 = val_length1;
#line 43 "utils.vala"
	if (result_length1) {
#line 43 "utils.vala"
		*result_length1 = _tmp5__length1;
#line 303 "utils.c"
	}
#line 43 "utils.vala"
	result = _tmp5_;
#line 43 "utils.vala"
	return result;
#line 309 "utils.c"
}

gchar*
utils_key_file_get_locale_string (GKeyFile* kf,
                                  const gchar* group,
                                  const gchar* key,
                                  const gchar* def_val)
{
	gchar* val = NULL;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 46 "utils.vala"
	g_return_val_if_fail (kf != NULL, NULL);
#line 46 "utils.vala"
	g_return_val_if_fail (group != NULL, NULL);
#line 46 "utils.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 327 "utils.c"
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 49 "utils.vala"
		_tmp1_ = g_key_file_get_locale_string (kf, group, key, NULL, &_inner_error0_);
#line 49 "utils.vala"
		_tmp0_ = _tmp1_;
#line 49 "utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 49 "utils.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 340 "utils.c"
				goto __catch0_g_key_file_error;
			}
#line 49 "utils.vala"
			_g_free0 (val);
#line 49 "utils.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 49 "utils.vala"
			g_clear_error (&_inner_error0_);
#line 49 "utils.vala"
			return NULL;
#line 351 "utils.c"
		}
#line 49 "utils.vala"
		_tmp2_ = _tmp0_;
#line 49 "utils.vala"
		_tmp0_ = NULL;
#line 49 "utils.vala"
		_g_free0 (val);
#line 49 "utils.vala"
		val = _tmp2_;
#line 48 "utils.vala"
		_g_free0 (_tmp0_);
#line 363 "utils.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		gchar* _tmp3_;
#line 48 "utils.vala"
		g_clear_error (&_inner_error0_);
#line 52 "utils.vala"
		_tmp3_ = g_strdup (def_val);
#line 52 "utils.vala"
		_g_free0 (val);
#line 52 "utils.vala"
		val = _tmp3_;
#line 377 "utils.c"
	}
	__finally0:
#line 48 "utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 48 "utils.vala"
		_g_free0 (val);
#line 48 "utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 48 "utils.vala"
		g_clear_error (&_inner_error0_);
#line 48 "utils.vala"
		return NULL;
#line 390 "utils.c"
	}
#line 54 "utils.vala"
	result = val;
#line 54 "utils.vala"
	return result;
#line 396 "utils.c"
}

gboolean
utils_key_file_get_bool (GKeyFile* kf,
                         const gchar* group,
                         const gchar* key,
                         gboolean def_val)
{
	gboolean val = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 57 "utils.vala"
	g_return_val_if_fail (kf != NULL, FALSE);
#line 57 "utils.vala"
	g_return_val_if_fail (group != NULL, FALSE);
#line 57 "utils.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 414 "utils.c"
	{
		gboolean _tmp0_ = FALSE;
#line 60 "utils.vala"
		_tmp0_ = g_key_file_get_boolean (kf, group, key, &_inner_error0_);
#line 60 "utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 421 "utils.c"
			gboolean _tmp1_ = FALSE;
#line 60 "utils.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 425 "utils.c"
				goto __catch0_g_key_file_error;
			}
#line 60 "utils.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 60 "utils.vala"
			g_clear_error (&_inner_error0_);
#line 60 "utils.vala"
			return _tmp1_;
#line 434 "utils.c"
		}
#line 60 "utils.vala"
		val = _tmp0_;
#line 438 "utils.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
#line 59 "utils.vala"
		g_clear_error (&_inner_error0_);
#line 63 "utils.vala"
		val = def_val;
#line 447 "utils.c"
	}
	__finally0:
#line 59 "utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 452 "utils.c"
		gboolean _tmp2_ = FALSE;
#line 59 "utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 59 "utils.vala"
		g_clear_error (&_inner_error0_);
#line 59 "utils.vala"
		return _tmp2_;
#line 460 "utils.c"
	}
#line 65 "utils.vala"
	result = val;
#line 65 "utils.vala"
	return result;
#line 466 "utils.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

